// http://www.johndcook.com/blog/2008/11/17/fast-way-to-test-whether-a-number-is-a-square/

#include <math.h>

char bad255[512] =
{0,0,1,1,0,1,1,1,1,0,1,1,1,1,1,0,0,1,1,0,1,0,1,1,1,0,1,1,1,1,0,1,
 1,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,1,1,1,0,1,1,1,1,0,1,1,1,
 0,1,0,1,1,0,0,1,1,1,1,1,0,1,1,1,1,0,1,1,0,0,1,1,1,1,1,1,1,1,0,1,
 1,1,1,1,0,1,1,1,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,0,1,1,1,1,1,1,
 1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,1,1,0,1,1,1,1,1,
 1,1,1,1,1,1,0,1,1,0,1,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,1,1,
 1,1,1,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,
 1,0,1,1,1,0,1,1,1,1,0,1,1,1,1,1,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,
 0,0,1,1,0,1,1,1,1,0,1,1,1,1,1,0,0,1,1,0,1,0,1,1,1,0,1,1,1,1,0,1,
 1,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,1,1,1,0,1,1,1,1,0,1,1,1,
 0,1,0,1,1,0,0,1,1,1,1,1,0,1,1,1,1,0,1,1,0,0,1,1,1,1,1,1,1,1,0,1,
 1,1,1,1,0,1,1,1,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,1,0,0,1,1,1,1,1,1,
 1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,1,1,0,1,1,1,1,1,
 1,1,1,1,1,1,0,1,1,0,1,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,1,1,
 1,1,1,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,
 1,0,1,1,1,0,1,1,1,1,0,1,1,1,1,1,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,
 0,0};

// return: < 0 if x is not a square, r if r*r == x and r >= 0
int exactSquareRoot(long x)
{
  // Quickfail
  if (x < 0 || (x & 2) || (x & 7) == 5 || (x & 11) == 8) return -1;
  if (x == 0) return 0;
  // Check mod 255 = 3 * 5 * 17, for fun
  long y = x;
  y = (y & 4294967295L) + (y >> 32);
  y = (y & 65535) + (y >> 16);
  y = (y & 255) + ((y >> 8) & 255) + (y >> 16);
  if (bad255[y]) return -1;
  // Divide out powers of 4 using binary search
  y = x;
  if ((y & 4294967295L) == 0) y >>= 32;
  if ((y & 65535) == 0) y >>= 16;
  if ((y & 255) == 0) y >>= 8;
  if ((y & 15) == 0) y >>= 4;
  if ((y & 3) == 0) y >>= 2;
  if ((y & 7) != 1) return -1;
  int r = (int)sqrt(x);
  return (r * (long)r == x) ? r : -1;
}

int isSquare(long x) { return exactSquareRoot(x) >= 0; }

